program fastwebp;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, CustApp, Process
  { you can add units after this };

type

  { Twebp }

  Twebp = class(TCustomApplication)
  protected
    procedure DoRun; override;
  public
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
  end;

{ Twebp }

procedure Twebp.DoRun;
var
  str: String;
  n, fsize: integer;
  AProcess: TProcess;
  AStringList: TStringList;
  f: File;
begin
  AStringList := TStringList.Create;
  if FileExists(ExtractFilePath(ParamStr(0))+'fastwebp.log') = true then
    begin
      AStringList.LoadFromFile(ExtractFilePath(ParamStr(0))+'fastwebp.log');
      AStringList.Add('');
    end;
  AStringList.Add('Date: '+TimeToStr(now));
  AStringList.Add('ParamCount: '+IntToStr(ParamCount));

  if FileExists(ExtractFilePath(ParamStr(0))+'cwebp.exe') = true then
    begin
      for n := 1 to ParamCount do
        begin
          if (ExtractFileExt(ParamStr(n)) = '.png') or (ExtractFileExt(ParamStr(n)) = '.jpg') or (ExtractFileExt(ParamStr(n)) = '.jpeg') then
            begin
              AProcess := TProcess.Create(nil);
              str := ExtractFileName(ParamStr(n));
              if ExtractFileExt(ParamStr(n)) = '.jpeg'
                then SetLength(str, Length(str)-5)
                else SetLength(str, Length(str)-4);
              AProcess.CommandLine := 'cwebp '+ParamStr(n)+' -o '+str+'.webp';
              AStringList.Add('Command: '+AProcess.CommandLine);
              AProcess.ShowWindow := swohide;
              AProcess.WaitOnExit;
              AProcess.Execute;
              AProcess.Free;
              AStringList.Add('Success: it may have work.');
            end else
          if ExtractFileExt(ParamStr(n)) = '.webp' then
            begin
              AProcess := TProcess.Create(nil);
              str := ExtractFileName(ParamStr(n));
              SetLength(str, Length(str)-5);
              AProcess.CommandLine := 'dwebp '+ParamStr(n)+' -o '+str+'.png';
              AStringList.Add('Command: '+AProcess.CommandLine);
              AProcess.ShowWindow := swohide;
              AProcess.WaitOnExit;
              AProcess.Execute;
              AProcess.Free;
              AStringList.Add('Success: it may have work.');
            end else AStringList.Add('Error: files have to be this type: .webp, .png, .jpg or .jpeg!');
        end;
    end else AStringList.Add('Error: cwebp.exe has to be in program dir!');

  AStringList.SaveToFile(ExtractFilePath(ParamStr(0))+'fastwebp.log');
  AStringList.Free;

  if FileExists(ExtractFilePath(ParamStr(0))+'fastwebp.log') = true then
    begin
      AssignFile(f, ExtractFilePath(ParamStr(0))+'fastwebp.log');
      reset(f,1);
      fsize := FileSize(f);
      CloseFile(f);
      fsize := round(fsize/1024/1024);
      if fsize > 2 then
        begin
          if FileExists(ExtractFilePath(ParamStr(0))+'fastwebp.old') = true
            then DeleteFile(ExtractFilePath(ParamStr(0))+'fastwebp.old');
          RenameFile(ExtractFilePath(ParamStr(0))+'fastwebp.log', ExtractFilePath(ParamStr(0))+'fastwebp.old');
        end;
    end;

  //stop program loop
  Terminate;
end;

constructor Twebp.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
end;

destructor Twebp.Destroy;
begin
  inherited Destroy;
end;

var
  Application: Twebp;

{$R *.res}

begin
  Application:=Twebp.Create(nil);
  Application.Run;
  Application.Free;
end.

